﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace SpecialTextField
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            SpecialTextField test = new SpecialTextField(this.textControl1, "TextField测试", 30, '$');
            this.textControl1.TextFields.Add(test);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
        }
    }
    public class SpecialTextField : TXTextControl.TextField
    {
        int _specialMaxLength;
        string _specialText;
        char _specialFillChar = 'x';
        TXTextControl.TextControl _specialTX;

        public SpecialTextField(TXTextControl.TextControl textControl,string text,int maxLength,char fillChar)
        {
            _specialTX = textControl;
            _specialText = text;
            _specialMaxLength = maxLength;
            _specialFillChar = fillChar;

            this.ShowActivated = true;
            this.DoubledInputPosition = true;
            this.Deleteable = true;

            base.Text = _specialText + new String(_specialFillChar, _specialMaxLength - _specialText.Length);

            _specialTX.TextFieldLeft += new TXTextControl.TextFieldEventHandler(_specialTX_TextFieldLeft);
            _specialTX.TextFieldChanged += new TXTextControl.TextFieldEventHandler(_specialTX_TextFieldChanged);
        }

        void _specialTX_TextFieldChanged(object sender, TXTextControl.TextFieldEventArgs e)
        {
            CleanTextField(e.TextField);
        }

        void _specialTX_TextFieldLeft(object sender, TXTextControl.TextFieldEventArgs e)
        {
            CleanTextField(e.TextField);
        }

        private void CleanTextField(TXTextControl.TextField TextField)
        {
            if (TextField.Length < _specialMaxLength)
            {
                TextField.Text += new String(_specialFillChar, _specialMaxLength - TextField.Text.Length);
            }
            else if (TextField.Length > _specialMaxLength)
            {
                TextField.Text = TextField.Text.Remove(TextField.Text.Length - 1, 1);
            }
        }
    }
}
